'DirectDraw 7 example support file for HotBasic v5.0a
'By Don
'February 07, 2007.

' ----------------------------------------------------------------------
' Structures
' ----------------------------------------------------------------------
type GUID
  iid1 as dword
  iid2 as dword
  iid3 as dword
  iid4 as dword
end type

dim IID_IDirectDraw7 as GUID

with IID_IDirectDraw7
  .iid1 = &H15E65EC0
  .iid2 = &H11D23B9C
  .iid3 = &H60002FB9
  .iid4 = &H5BEA9797
end with

type DDSCAPS2
  dwCaps  as dword
  dwCaps2 as dword
  dwCaps3 as dword
  dwCaps4 as dword
end type

type DDCOLORKEY
    dwColorSpaceLowValue  as dword
    dwColorSpaceHighValue as dword
end type

type DDSURFACEDESC2
  dwSize   as dword
  dwFlags  as dword
  dwHeight as dword
  dwWidth  as dword

  'UNION u1
    lPitch       as long
  ' dwLinearSize as dword
  'end UNION

  dwBackBufferCount as dword

  'UNION u2
    dwMipMapCount as dword
  ' dwRefreshRate as dword
  'end UNION

  dwAlphaBitDepth as dword
  dwReserved      as dword
  lpSurface       as dword

  'UNION u3
  ' ddckCKDestOverlay as DDCOLORKEY
     ddckCKDestOverlay_dwColorSpaceLowValue  as dword
     ddckCKDestOverlay_dwColorSpaceHighValue as dword
  ' end DDCOLORKEY
  ' dwEmptyFaceColor as dword
  'end UNION

  'ddckCKDestBlt as DDCOLORKEY
    ddckCKDestBlt_dwColorSpaceLowValue  as dword
    ddckCKDestBlt_dwColorSpaceHighValue as dword
  'end DDCOLORKEY 

  'ddckCKSrcOverlay as DDCOLORKEY
    ddckCKSrcOverlay_dwColorSpaceLowValue  as dword
    ddckCKSrcOverlay_dwColorSpaceHighValue as dword
  'end DDCOLORKEY 

  'ddckCKSrcBlt as DDCOLORKEY
    ddckCKSrcBlt_dwColorSpaceLowValue  as dword
    ddckCKSrcBlt_dwColorSpaceHighValue as dword
  'end DDCOLORKEY 

  'UNION u4
  ' ddpfPixelFormat as DDPIXELFORMAT
     ddpfPixelFormat_dwSize   as dword
     ddpfPixelFormat_dwFlags  as dword
     ddpfPixelFormat_dwFourCC as dword
     ddpfPixelFormat_u1       as dword
     ddpfPixelFormat_u2       as dword
     ddpfPixelFormat_u3       as dword
     ddpfPixelFormat_u4       as dword
     ddpfPixelFormat_u5       as dword
  ' end DDPIXELFORMAT

  ' dwFVF as dword
  'end UNION

  'ddsCaps as DDSCAPS2
    ddsCaps_dwCaps  as dword
    ddsCaps_dwCaps2 as dword
    ddsCaps_dwCaps3 as dword
    ddsCaps_dwCaps4 as dword
  'end DDCAPS2

  dwTextureStage as dword
end type


' ----------------------------------------------------------------------
' Constants
' ----------------------------------------------------------------------
$define LPDIRECTDRAWSURFACE7 LONG
$define LPDIRECTDRAW7 LONG

$define SRCCOPY &HCC0020
$define SM_CXSCREEN 0
$define SM_CYSCREEN 1
$define VK_ESCAPE 27
$define WM_QUIT 18
$define WS_EX_TOPMOST 8
$define WS_POPUP &H80000000

$define DD_OK 0
$define DDCKEY_SRCBLT &H00000008
$define DDBLTFAST_NOCOLORKEY &H00000000
$define DDBLTFAST_SRCCOLORKEY &H00000001
$define DDERR_OUTOFVIDEOMEMORY &H088760380
$define DDERR_SURFACELOST &H088760450
$define DDERR_WASSTILLDRAWING &H088760540
$define DDSD_BACKBUFFERCOUNT &H00000020
$define DDSD_CAPS &H00000001
$define DDSD_HEIGHT &H00000002
$define DDSD_WIDTH &H00000004
$define DDSCAPS_COMPLEX &H00000008
$define DDSCAPS_BACKBUFFER &H00000004
$define DDSCAPS_FLIP &H00000010
$define DDSCAPS_OFFSCREENPLAIN &H00000040
$define DDSCAPS_PRIMARYSURFACE &H00000200
$define DDSCAPS_SYSTEMMEMORY &H00000800
$define DDSCAPS_VIDEOMEMORY &H00004000
$define DDSCL_NORMAL 8
$define DDSCL_EXCLUSIVE &H00000010
$define DDSCL_FULLSCREEN &H00000001

' ----------------------------------------------------------------------
' External DLL imports
' ----------------------------------------------------------------------
declare sub DirectDrawCreateEx lib "ddraw"   (iArg1 as dword, iArg2 as dword, iArg3 as dword, iArg4 as dword)
declare sub ZeroMemory         lib "kernel32" Alias "RtlZeroMemory" (iArg1 as dword, iArg2 as dword)

declare function GetMethodAddr(ppvObj as dword, m_id as dword) as dword

function GetMethodAddr
  result = byref(byref(ppvObj) + m_id)
end function

' ----------------------------------------------------------------------
' IUnknown Interface
' ----------------------------------------------------------------------
declare sub IUnknown_Release        (ppvObj as dword)
defint DDRet

sub IUnknown_Release
  defint ppMethod = GetMethodAddr(ppvObj, 8)
  funccall(ppMethod, ppvObj)
  DDRet = retfunc
end sub

' ----------------------------------------------------------------------
' IDirectDraw7 Interface
' ----------------------------------------------------------------------
declare sub IDirectDraw7_CreateSurface       (ppvObj as dword, iArg1 as dword, iArg2 as dword, iArg3 as dword)
declare sub IDirectDraw7_RestoreDisplayMode  (ppvObj as dword)
declare sub IDirectDraw7_SetCooperativeLevel (ppvObj as dword, iArg1 as dword, iArg2 as dword)
declare sub IDirectDraw7_SetDisplayMode      (ppvObj as dword, iArg1 as dword, iArg2 as dword, iArg3 as dword, iArg4 as dword, iArg5 as dword)

sub IDirectDraw7_CreateSurface
  defint ppMethod = GetMethodAddr(ppvObj, 24)
  funccall(ppMethod, ppvObj, iArg1, iArg2, iArg3)
  DDRet = retfunc
end sub

sub IDirectDraw7_RestoreDisplayMode
  defint ppMethod = GetMethodAddr(ppvObj, 76)
  funccall(ppMethod, ppvObj)
  DDRet = retfunc
end sub

sub IDirectDraw7_SetCooperativeLevel
  defint ppMethod = GetMethodAddr(ppvObj, 80)
  funccall(ppMethod, ppvObj, iArg1, iArg2)
  DDRet = retfunc
end sub

sub IDirectDraw7_SetDisplayMode
  defint ppMethod = GetMethodAddr(ppvObj, 84)
  funccall(ppMethod, ppvObj, iArg1, iArg2, iArg3, iArg4, iArg5)
  DDRet = retfunc
end sub

' ----------------------------------------------------------------------
' IDirectDrawSurface7 Interface
' ----------------------------------------------------------------------
declare sub      IDirectDrawSurface7_BltFast            (ppvObj as dword, iArg1 as dword, iArg2 as dword, iArg3 as dword, iArg4 as dword, iArg5 as dword)
declare sub      IDirectDrawSurface7_Flip               (ppvObj as dword, iArg1 as dword, iArg2 as dword)
declare sub      IDirectDrawSurface7_GetAttachedSurface (ppvObj as dword, iArg1 as dword, iArg2 as dword)
declare function IDirectDrawSurface7_GetDC              (ppvObj as dword) as dword
declare sub      IDirectDrawSurface7_GetSurfaceDesc     (ppvObj as dword, iArg1 as dword)
declare sub      IDirectDrawSurface7_Restore            (ppvObj as dword)
declare sub      IDirectDrawSurface7_ReleaseDC          (ppvObj as dword, iArg1 as dword)
declare sub      IDirectDrawSurface7_SetColorKey        (ppvObj as dword, iArg1 as dword, iArg2 as dword)

sub IDirectDrawSurface7_BltFast
  defint ppMethod = GetMethodAddr(ppvObj, 28)
  funccall(ppMethod, ppvObj, iArg1, iArg2, iArg3, iArg4, iArg5)
  DDRet = retfunc
end sub

sub IDirectDrawSurface7_Flip
  defint ppMethod = GetMethodAddr(ppvObj, 44)
  funccall(ppMethod, ppvObj, iArg1, iArg2)
  DDRet = retfunc
end sub

sub IDirectDrawSurface7_GetAttachedSurface
  defint ppMethod = GetMethodAddr(ppvObj, 48)
  funccall(ppMethod, ppvObj, iArg1, iArg2)
  DDRet = retfunc
end sub

function IDirectDrawSurface7_GetDC
  defint ppGet, ppMethod = GetMethodAddr(ppvObj, 68)
  funccall(ppMethod, ppvObj, @ppGet)
  DDRet = retfunc
  result = ppGet
end function

sub IDirectDrawSurface7_GetSurfaceDesc
  defint ppMethod = GetMethodAddr(ppvObj, 88)
  funccall(ppMethod, ppvObj, iArg1)
  DDRet = retfunc
end sub

sub IDirectDrawSurface7_ReleaseDC
  defint ppMethod = GetMethodAddr(ppvObj, 104)
  funccall(ppMethod, ppvObj, iArg1)
  DDRet = retfunc
end sub

sub IDirectDrawSurface7_Restore
  defint ppMethod = GetMethodAddr(ppvObj, 108)
  funccall(ppMethod, ppvObj)
  DDRet = retfunc
end sub

sub IDirectDrawSurface7_SetColorKey
  defint ppMethod = GetMethodAddr(ppvObj, 116)
  funccall(ppMethod, ppvObj, iArg1, iArg2)
  DDRet = retfunc
end sub

